                    Quarterdeck Technical Note

         Patching QRAM 2.00 and QEMM-386 6.00 and 6.01 to force 
         recognition of Chips and Technologies ShadowRAM 

     Background:  QEMM-386 and QRAM try to automatically detect 
     several different implementations of Chips and Technologies 
     ShadowRAM - AT/386, NEAT, and SCAT - and to reclaim as much 
     of the memory as possible for other uses.  However, due to 
     differences among the different machines that use ShadowRAM, 
     QEMM-386 and QRAM sometimes fail to detect ShadowRAM that 
     they are in fact equipped to use.

     The Zenith Supersport 286 is an example of a machine that 
     contains usable NEAT ShadowRAM that is not detected by QRAM 
     2.00.  

     QEMM-386 and QRAM can be patched to force them to recognize 
     a particular type of Chips and Technologies ShadowRAM.  It 
     is important to note that the following patch, while making 
     QEMM-386 and QRAM recognize ShadowRAM, will also make that 
     copy of QEMM-386 or QRAM incompatible with any system that 
     does not contain the specific type of ShadowRAM that QEMM-
     386 or QRAM was patched to detect.  

     The following procedure is intended to force QEMM-386 6.00 
     and 6.01 and QRAM 2.00 to detect one of three different 
     kinds of Chips and Technologies ShadowRAM. 


         -------------------------------------------------

     We will use QRAM 2.00 and its device driver QRAM.SYS in the 
     following example.  However, the same procedure can be used 
     to patch QEMM-386 6.00 and 6.01 and its device driver 
     QEMM386.SYS.


     1) Make a copy of the QRAM.SYS file in your QRAM directory.  We are 
     about to alter your current copy of QRAM.SYS; the copy you make 
     will serve as a backup in case this operation fails.

           COPY C:\QRAM\QRAM.SYS C:\QRAM\QRAMOLD.SYS

     (If your QRAM.SYS is not located in the QRAM directory of the C: 
     drive, change the path accordingly.)

     2) Go to the DOS directory on the hard disk and type:

                     DEBUG C:\QRAM\QRAM.SYS

     (If your QRAM.SYS is not located in the QRAM directory of the C: 
     drive, change the path accordingly.)

     Hit the Enter key; you should the the DEBUG prompt, which is a hyphen.

     3) At the DEBUG prompt, type:

                        S 100 L F000 B0 0 72

     Hit the Enter key; DEBUG should return a segment address and 
     an offset:

                             xxxx:yyyy

     (If two addresses are returned, use the first.)

     The value of yyyy should be 1461 for QRAM 2.00, 558E for 
     QEMM-386 6.00, and 55CE for QEMM-386 6.01.

     4) At the DEBUG prompt again, use the segment address and 
     offset that was just returned to give ONLY ONE of the 
     following three DEBUG commands.  

     If you wish to force QRAM or QEMM-386 to recognize the NEAT 
     or the LEAP chip set (used by the Zenith Supersport 286), 
     enter the command:

                          E xxxx:yyyy B0 80 EB
   

     If you wish to force QRAM or QEMM-386 to recognize the 
     AT/386 chip set, enter the command:

                          E xxxx:yyyy B0 40 EB


     If you wish to force QRAM or QEMM-386 to recognize the SCAT
     chip set, enter the command:

                          E xxxx:yyyy B0 20 EB


     The address that DEBUG returned in step 3 should be used in 
     place of the address xxxx:yyyy, which we use as an example.  
     Hit the Enter key; the DEBUG prompt should return in a 
     moment.


     5) At the DEBUG prompt, type

                                 W

     Hit the Enter key; DEBUG will announce that it is writing a certain 
     number of bytes, then it will return the DEBUG prompt.

     6) At the DEBUG prompt, type

                                 Q

     Hit the Enter key to exit DEBUG and return to DOS.

        --------------------------------------------------

     If the system fails after you perform this patch, copy the backup of 
     QRAM that you made back to its original name.  

           COPY C:\QRAM\QRAMOLD.SYS C:\QRAM\QRAM.SYS

     (If your QRAM.SYS is not located in the QRAM directory of the C: 
     drive, change the path accordingly.)

     You may then wish to try the above procedure again, in case a mistake 
     was made.

              * * *   E N D   O F   F I L E    * * *
